#!usr/bin/env python3

import RPi.GPIO as GPIO
import time
from sudo import run_as_sudo

import epd2in7b
from PIL import Image
from PIL import ImageFont
from PIL import ImageDraw

def up (callback):
	global exe_flag
	global sudo_user
	#epd.Clear()
	#print ('EPD Cleared!')
	if exe_flag == 0:
		exe_flag = 1
	else:
		exe_flag = exe_flag
	print ('Online Mode Selected!')
	print ('Exe_flag: ',exe_flag)
	time.sleep(1)
	#epd.sleep()
	#print ('EPD entering Sleep Mode!')
	#time.sleep(1)
	file = open("/home/pi/TA/Python/flag.txt", "w")
	file.write("2-Online")
	file.close()
	print ('Flag Overwritten!')
	time.sleep(1)
	run_as_sudo(sudo_user, 'sudo \cp /etc/dhcpcd.disableAP.conf /etc/dhcpcd.conf', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/network/interfaces.disableAP /etc/network/interfaces', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/hostapd/hostapd.disableAP /etc/hostapd/hostapd.conf', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/default/hostapd.disableAP /etc/default/hostapd', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/dnsmasq.disableAP /etc/dnsmasq.conf', shell=True)
	run_as_sudo(sudo_user, 'sudo systemctl mask hostapd', shell=True)
	run_as_sudo(sudo_user, 'sudo systemctl stop hostapd dnsmasq', shell=True)
	run_as_sudo(sudo_user, 'sudo systemctl disable hostapd dnsmasq', shell=True)
	run_as_sudo(sudo_user, 'sudo reboot')
	quit()

def down (callback):
	global exe_flag
	global sudo_user
	#epd.Clear()
	#print('EPD Cleared!')
	if exe_flag == 0:
		exe_flag = 1
	else:
		exe_flag = exe_flag
	print ('Offline Mode Selected!')
	print ('Exe_flag: ',exe_flag)
	#epd.sleep()
	#print ('EPD entering Sleep Mode!')
	#time.sleep(1)
	file = open("/home/pi/TA/Python/flag.txt", "w")
	file.write("2-Offline")
	file.close()
	print ('Flag Overwritten!')
	time.sleep(1)
	run_as_sudo(sudo_user, 'sudo \cp /etc/dhcpcd.enableAP.conf /etc/dhcpcd.conf', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/network/interfaces.enableAP /etc/network/interfaces', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/hostapd/hostapd.enableAP /etc/hostapd/hostapd.conf', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/default/hostapd.enableAP /etc/default/hostapd', shell=True)
	run_as_sudo(sudo_user, 'sudo \cp /etc/dnsmasq.enableAP /etc/dnsmasq.conf', shell=True)
	run_as_sudo(sudo_user, 'sudo systemctl unmask hostapd', shell=True)
	run_as_sudo(sudo_user, 'sudo systemctl enable hostapd dnsmasq', shell=True)
	run_as_sudo(sudo_user, 'sudo reboot')
	quit()

#def enter (channel):
#	print ('Button 1 Pressed!')

def UpdateDisplay (string1):
	Image1 = Image.new('1', (epd2in7b.EPD_WIDTH, epd2in7b.EPD_HEIGHT), 255).transpose(Image.ROTATE_270)
	Image2 = Image.new('1', (epd2in7b.EPD_WIDTH, epd2in7b.EPD_HEIGHT), 255).transpose(Image.ROTATE_270)

	draw1 = ImageDraw.Draw(Image1)
	#draw2 = ImageDraw.Draw(Image2)
	font = ImageFont.truetype('/home/pi/TA/Python/Bookerly-Italic.ttf', 20)

	draw1.text((10,10), string1, font=font, fill=0)
	#draw2.text((10,60), string2, font=font, fill=0)
	epd.display(epd.getbuffer(Image1), epd.getbuffer(Image2))

epd = epd2in7b.EPD()

String1 = "Select Mode: \n \n"
String2 = "Online \n \n Offline"

GPIO.setmode(GPIO.BOARD)

#Execute = 29
UpButton = 31
DownButton = 33

#GPIO.setup (Execute, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup (UpButton, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup (DownButton, GPIO.IN, pull_up_down=GPIO.PUD_UP)


#GPIO.add_event_detect(Execute, GPIO.FALLING, callback=enter, bouncetime=1000)

exe_flag = 0
sudo_user = 'pi'

try:
	epd.init()
	UpdateDisplay (String1 + String2)
	GPIO.add_event_detect(UpButton, GPIO.FALLING, callback=up, bouncetime=2000)
	GPIO.add_event_detect(DownButton, GPIO.FALLING, callback=down, bouncetime=2000)

	while True:
		#if GPIO.input(UpButton) == GPIO.LOW:
		#	up()
		#elif GPIO.input(DownButton) == GPIO.LOW:
		#	down()
		#else:
		#	print ('No Button Pressed!')
		time.sleep(1)

except:
	pass
